##############################
#                            #
# Ansible / Tower managed on #
#                            #
##############################

# This is the main Apache server configuration file.  It contains the
# configuration directives that give the server its instructions.
# See http://httpd.apache.org/docs/2.4/ for detailed information about
# the directives and /usr/share/doc/apache2/README.Debian about Debian specific
# hints.
#
#
# Summary of how the Apache 2 configuration works in Debian:
# The Apache 2 web server configuration in Debian is quite different to
# upstream's suggested way to configure the web server. This is because Debian's
# default Apache2 installation attempts to make adding and removing modules,
# virtual hosts, and extra configuration directives as flexible as possible, in
# order to make automating the changes and administering the server as easy as
# possible.

# It is split into several files forming the configuration hierarchy outlined
# below, all located in the /etc/apache2/ directory:
#
#       /etc/apache2/
#       |-- apache2.conf
#       |       `--  ports.conf
#       |-- mods-enabled
#       |       |-- *.load
#       |       `-- *.conf
#       |-- conf-enabled
#       |       `-- *.conf
#       `-- sites-enabled
#               `-- *.conf
#
#
# * apache2.conf is the main configuration file (this file). It puts the pieces
#   together by including all remaining configuration files when starting up the
#   web server.
#
# * ports.conf is always included from the main configuration file. It is
#   supposed to determine listening ports for incoming connections which can be
#   customized anytime.
#
# * Configuration files in the mods-enabled/, conf-enabled/ and sites-enabled/
#   directories contain particular configuration snippets which manage modules,
#   global configuration fragments, or virtual host configurations,
#   respectively.
#
#   They are activated by symlinking available configuration files from their
#   respective *-available/ counterparts. These should be managed by using our
#   helpers a2enmod/a2dismod, a2ensite/a2dissite and a2enconf/a2disconf. See
#   their respective man pages for detailed information.
#
# * The binary is called apache2. Due to the use of environment variables, in
#   the default configuration, apache2 needs to be started/stopped with
#   /etc/init.d/apache2 or apache2ctl. Calling /usr/bin/apache2 directly will not
#   work with the default configuration.


# Global configuration
#

#
# ServerRoot: The top of the directory tree under which the server's
# configuration, error, and log files are kept.
#
# NOTE!  If you intend to place this on an NFS (or otherwise network)
# mounted filesystem then please read the Mutex documentation (available
# at <URL:http://httpd.apache.org/docs/2.4/mod/core.html#mutex>);
# you will save yourself a lot of trouble.
#
# Do NOT add a slash at the end of the directory path.
#
#ServerRoot "/etc/apache2"

#
# The accept serialization lock file MUST BE STORED ON A LOCAL DISK.
#
Mutex file:${APACHE_LOCK_DIR} default

#
# PidFile: The file in which the server should record its process
# identification number when it starts.
# This needs to be set in /etc/apache2/envvars
#
PidFile ${APACHE_PID_FILE}

#
# Timeout: The number of seconds before receives and sends time out.
#
Timeout 600

#
# KeepAlive: Whether or not to allow persistent connections (more than
# one request per connection). Set to "Off" to deactivate.
#
KeepAlive On

#
# MaxKeepAliveRequests: The maximum number of requests to allow
# during a persistent connection. Set to 0 to allow an unlimited amount.
# We recommend you leave this number high, for maximum performance.
#
MaxKeepAliveRequests 100

#
# KeepAliveTimeout: Number of seconds to wait for the next request from the
# same client on the same connection.
#
KeepAliveTimeout 5

# These need to be set in /etc/apache2/envvars
#User ${APACHE_RUN_USER}
#Group ${APACHE_RUN_GROUP}

User {{ install_apache.system_user }}
Group {{ install_apache.system_group }}

#
# HostnameLookups: Log the names of clients or just their IP addresses
# e.g., www.apache.org (on) or 204.62.129.132 (off).
# The default is off because it'd be overall better for the net if people
# had to knowingly turn this feature on, since enabling it means that
# each client request will result in AT LEAST one lookup request to the
# nameserver.
#
HostnameLookups Off
ServerTokens ProductOnly

# ErrorLog: The location of the error log file.
# If you do not specify an ErrorLog directive within a <VirtualHost>
# container, error messages relating to that virtual host will be
# logged here.  If you *do* define an error logfile for a <VirtualHost>
# container, that host's errors will be logged there and not here.
#
ErrorLog ${APACHE_LOG_DIR}/error.log

#
# LogLevel: Control the severity of messages logged to the error_log.
# Available values: trace8, ..., trace1, debug, info, notice, warn,
# error, crit, alert, emerg.
# It is also possible to configure the log level for particular modules, e.g.
# "LogLevel info ssl:warn"
#
LogLevel {{ install_apache.loglevel }}

# Include module configuration:
IncludeOptional mods-enabled/*.load
IncludeOptional mods-enabled/*.conf

# Include list of ports to listen on
Include ports.conf


# Sets the default security model of the Apache2 HTTPD server. It does
# not allow access to the root filesystem outside of /usr/share and /var/www.
# The former is used by web applications packaged in Debian,
# the latter may be used for local directories served by the web server. If
# your system is serving content from a sub-directory in /srv you must allow
# access here, or in any related virtual host.
<Directory />
        Options -Indexes -FollowSymLinks
        AllowOverride None
        Require all denied
</Directory>

<Directory /usr/share>
        Options -Indexes -FollowSymLinks
        AllowOverride None
        Require all denied
</Directory>

<Directory /var/www/>
        Options -Indexes -FollowSymLinks
        AllowOverride None
        Require all denied
</Directory>

<Directory /srv/>
        Options -Indexes -FollowSymLinks
        AllowOverride None
        Require all denied
</Directory>

# AccessFileName: The name of the file to look for in each directory
# for additional configuration directives.  See also the AllowOverride
# directive.
#
AccessFileName .htaccess

#
# The following lines prevent .htaccess and .htpasswd files from being
# viewed by Web clients.
#
<FilesMatch "^\.ht">
        Require all denied
</FilesMatch>

#
# The following directives define some format nicknames for use with
# a CustomLog directive.
#
# These deviate from the Common Log Format definitions in that they use %O
# (the actual bytes sent including headers) instead of %b (the size of the
# requested file), because the latter makes it impossible to detect partial
# requests.
#
# Note that the use of %{X-Forwarded-For}i instead of %h is not recommended.
# Use mod_remoteip instead.
#
LogFormat "%v:%p %h %l %u %t \"%r\" %>s %O \"%{Referer}i\" \"%{User-Agent}i\"" vhost_combined
LogFormat "%h %l %u %t \"%r\" %>s %O \"%{Referer}i\" \"%{User-Agent}i\"" combined
LogFormat "%h %l %u %t \"%r\" %>s %O" common
LogFormat "%{Referer}i -> %U" referer
LogFormat "%{User-agent}i" agent

{% if install_apache__enable_evasive | default(false) %}
<IfModule mod_evasive20.c>
        DOSLogDir /var/log/apache2/mod_evasive.log
</IfModule>
{% endif %}

{% if install_apache__enable_security | default(false) %}
<IfModule security2_module>
        SecAuditLog /var/log/apache2/modsec_audit.log
</IfModule>
{% endif %}

{% if install_apache__enable_pagespeed | default(false) %}
<IfModule pagespeed_module>
        # Set the PageSpeed file cache directory
        ModPagespeedFileCachePath /var/www/html/mod_pagespeed
</IfModule>
{% endif %}

# Include of directories ignores editors' and dpkg's backup files,
# see README.Debian for details.

{% if install_apache__supplementary_mods.ldap.enabled | default(false) %}
# Add these line inside the main Apache2 conf file
LDAPSharedCacheSize 500000
LDAPCacheEntries 1024
LDAPCacheTTL 600
LDAPOpCacheEntries 1024
LDAPOpCacheTTL 600
LDAPVerifyServerCert {{ install_apache__supplementary_mods.ldap.verify_server_cert }}
{% endif %}

# Include generic snippets of statements
IncludeOptional conf-enabled/*.conf

# Include the virtual host configurations:
IncludeOptional sites-enabled/*.conf

Alias /http-check /var/www/html/blackhole/http-check
SetEnvIf Request_URI "^/http-check/index.gif$" blackhole-log
<Directory "/var/www/html/blackhole/http-check">
        Options -Indexes +FollowSymLinks
        AllowOverride None
        Order allow,deny
        Require all granted
        Allow from all

        SetEnvIf Request_Method OPTIONS blackhole-log
        SetEnvIf Request_URI "^/$" blackhole-log
</Directory>

<VirtualHost *:{{ install_apache.http_port }}>
        ServerName null
        ServerAlias *
        Redirect 403 /
        ServerSignature Off
        DocumentRoot /var/www/html/blackhole

        # Log ERROR and ACCESS handling
        LogFormat "%h %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-agent}i\"" combined
        SetEnvIf Request_Method OPTIONS blackhole-log
        SetEnvIf Request_URI "^/$" blackhole-log
        ErrorLog /var/www/html/blackhole/error.log
        CustomLog /var/www/html/blackhole/access.log combined env=!blackhole-log

        {% if install_apache__enable_evasive | default(false) %}
        <IfModule mod_evasive20.c>
                DOSLogDir /var/www/html/blackhole/mod_evasive.log
        </IfModule>
        {% endif %}
        {% if install_apache__enable_security | default(false) %}
        <IfModule security2_module>
                SecAuditLog /var/www/html/blackhole/modsec_audit.log
                SecAuditEngine Off
                #SecAuditEngine RelevantOnly
                SecAuditLogParts ABCFHZ 
                SecAuditLogType concurrent 
                SecAuditLogRelevantStatus ^(?:5|4(?!04))
        </IfModule>
        {% endif %}
        {% if install_apache__enable_pagespeed | default(false) %}
        <IfModule pagespeed_module>
                # Set the PageSpeed file cache directory
                ModPagespeedFileCachePath /var/www/html/blackhole/mod_pagespeed/
        </IfModule>
        {% endif %}

        <IfModule mod_ssl.c>
                # Redirect all HTTP traffic to HTTPS
                RewriteEngine On
                RewriteCond %{HTTPS} off
                RewriteRule ^(.*)$ https://%{HTTP_HOST}:{{ install_apache.https_port }}%{REQUEST_URI} [L,R=301]
        </IfModule>

</VirtualHost>

<IfModule mod_ssl.c>
<VirtualHost *:{{ install_apache.https_port }}>
        ServerName null
        ServerAlias *
        Redirect 403 /
        ServerSignature Off
        DocumentRoot /var/www/html/blackhole

        # Log ERROR and ACCESS handling
        LogFormat "%h %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-agent}i\"" combined
        SetEnvIf Request_Method OPTIONS blackhole-log
        SetEnvIf Request_URI "^/$" blackhole-log
        ErrorLog /var/www/html/blackhole/error.log
        CustomLog /var/www/html/blackhole/access.log combined env=!blackhole-log

        {% if install_apache__enable_evasive | default(false) %}
        <IfModule mod_evasive20.c>
                DOSLogDir /var/www/html/blackhole/mod_evasive.log
        </IfModule>
        {% endif %}
        {% if install_apache__enable_security | default(false) %}
        <IfModule security2_module>
                SecAuditLog /var/www/html/blackhole/modsec_audit.log
                SecAuditEngine Off
                #SecAuditEngine RelevantOnly
                SecAuditLogParts ABCFHZ 
                SecAuditLogType concurrent 
                SecAuditLogRelevantStatus ^(?:5|4(?!04))
        </IfModule>
        {% endif %}
        {% if install_apache__supplementary_mods.pagespeed.enabled | default(false) %}
        <IfModule pagespeed_module>
                # Set the PageSpeed file cache directory
                ModPagespeedFileCachePath /var/www/html/blackhole/mod_pagespeed/
        </IfModule>
        {% endif %}

        # Enable SSL/TLS and select a certificate
        SSLEngine on
        SSLCertificateFile {{ install_apache.ssl_cert }}
        SSLCertificateKeyFile {{ install_apache.ssl_key }}
        # Set the SSL/TLS cipher suite
        SSLCipherSuite ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256
        # Enable Forward Secrecy and disable SSLv3 and TLSv1
        SSLProtocol -all +TLSv1.2 +TLSv1.3
        SSLHonorCipherOrder on
        SSLCompression off
        SSLOptions +StrictRequire

</VirtualHost>
</IfModule>
